#include "stdafx.h"
#include "Image.h"


/*
#define DIB_ROW_BYTES(width,bpp) (((width)*(bpp)+31)/32*4)
*/
#define DIB_ROW_BYTES(width,bpp) ((((width)*(bpp)+31)>>5)<<2)




HGLOBAL ResizeImage(const BITMAPINFO *pbmiSrc,const void *pSrcData,
														int Width,int Height)
{
	HGLOBAL hGlobal;
	BITMAPINFOHEADER *pbmihDst;
	void *pDstData;
	int *pnSrcPos;
	int SrcPlanes,SrcXCenter,SrcYCenter,DstXCenter,DstYCenter;
	int x,y,x1,y1,dx1,dy1,dx2,dy2,YOffset;
	int b,g,r;
	int SrcRowBytes,DstPadBytes;
	const BYTE *p,*p1;
	BYTE *q;

	if (pbmiSrc->bmiHeader.biBitCount!=24 && pbmiSrc->bmiHeader.biBitCount!=32)
		return NULL;
	hGlobal=GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE,
					sizeof(BITMAPINFOHEADER)+DIB_ROW_BYTES(Width,24)*Height);
	if (hGlobal==NULL)
		return NULL;
	pbmihDst=(BITMAPINFOHEADER*)GlobalLock(hGlobal);
	pbmihDst->biSize=sizeof(BITMAPINFOHEADER);
	pbmihDst->biWidth=Width;
	pbmihDst->biHeight=Height;
	pbmihDst->biPlanes=1;
	pbmihDst->biBitCount=24;
	pbmihDst->biCompression=BI_RGB;
	pbmihDst->biSizeImage=0;
	pbmihDst->biXPelsPerMeter=0;
	pbmihDst->biYPelsPerMeter=0;
	pbmihDst->biClrUsed=0;
	pbmihDst->biClrImportant=0;
	pDstData=pbmihDst+1;
	pnSrcPos=(int*)malloc(Width*sizeof(int));
	if (pnSrcPos==NULL) {
		GlobalUnlock(hGlobal);
		GlobalFree(hGlobal);
		return false;
	}
	SrcPlanes=pbmiSrc->bmiHeader.biBitCount/8;
	SrcXCenter=((pbmiSrc->bmiHeader.biWidth-1)<<8)/2;
	SrcYCenter=((pbmiSrc->bmiHeader.biHeight-1)<<8)/2;
	DstXCenter=((Width-1)<<8)/2;
	DstYCenter=((Height-1)<<8)/2;
	for (x=0;x<Width;x++){
		pnSrcPos[x]=((x<<8)-DstXCenter)*pbmiSrc->bmiHeader.biWidth/Width+
																	SrcXCenter;
		if (pnSrcPos[x]<0)
			pnSrcPos[x]=0;
		else if (pnSrcPos[x]>(pbmiSrc->bmiHeader.biWidth-1)<<8)
			pnSrcPos[x]=(pbmiSrc->bmiHeader.biWidth-1)<<8;
	}
	SrcRowBytes=DIB_ROW_BYTES(pbmiSrc->bmiHeader.biWidth,
												pbmiSrc->bmiHeader.biBitCount);
	DstPadBytes=DIB_ROW_BYTES(Width,24)-Width*3;
	q=(BYTE*)pDstData;
	for (y=0;y<Height;y++){
		y1=((y<<8)-DstYCenter)*pbmiSrc->bmiHeader.biHeight/Height+SrcYCenter;
		if (y1<0)
			y1=0;
		else if (y1>(pbmiSrc->bmiHeader.biHeight-1)<<8)
			y1=(pbmiSrc->bmiHeader.biHeight-1)<<8;
		dy2=y1&0xFF;
		dy1=0x100-dy2;
		YOffset=dy2>0?SrcRowBytes:0;
		for (x=0;x<Width;x++){
			x1=pnSrcPos[x];
			dx2=x1&0xFF;
			dx1=0x100-dx2;
			p=(const BYTE*)pSrcData+(y1>>8)*SrcRowBytes+(x1>>8)*SrcPlanes;
			p1=p+((dx2+0xFF)>>8)*SrcPlanes;
			b=(p[0]*dx1+p1[0]*dx2)*dy1;
			g=(p[1]*dx1+p1[1]*dx2)*dy1;
			r=(p[2]*dx1+p1[2]*dx2)*dy1;
			p+=YOffset;
			p1+=YOffset;
			b+=(p[0]*dx1+p1[0]*dx2)*dy2;
			g+=(p[1]*dx1+p1[1]*dx2)*dy2;
			r+=(p[2]*dx1+p1[2]*dx2)*dy2;
			*q++=b>>16;
			*q++=g>>16;
			*q++=r>>16;
		}
		q+=DstPadBytes;
	}
	free(pnSrcPos);
	GlobalUnlock(hGlobal);
	return hGlobal;
}
